#include <bits/stdc++.h>
using namespace std;

using DPVal = int;
const int N = 1e5;
const int K = 100;
const int MAX_CASE_CNT = 1000;
const int UNKNOWN = -1;
const int MOD = 1e9+7;

map<int,int> ways[3]; // combine[how_many_nums][sum]
int filledin[N][2];

// fixed sums mod 3
uint32_t solve(int n, int k, array<int,3> sums/*, const vector<int,array<int,2>> & filledin*/) {
    uint64_t res = 1;
    int currentSum = 0, nums = 0;
    for (int c = 0; c < n; ++c) {
        if (filledin[c][0] == UNKNOWN && filledin[c][1] == UNKNOWN) {
            res = (res * ways[2][sums[c % 3]]) % MOD;
        } else if (filledin[c][0] != UNKNOWN && filledin[c][1] != UNKNOWN) {
            if (filledin[c][0] + filledin[c][1] != sums[c % 3])
                res = 0;
        } else if (filledin[c][0] != UNKNOWN) {
            res = (res * ways[1][sums[c % 3] - filledin[c][0]]) % MOD;
        } else if (filledin[c][1] != UNKNOWN) {
            res = (res * ways[1][sums[c % 3] - filledin[c][1]]) % MOD;
        }
    }
    return res;
}

int main() {
    ios::sync_with_stdio(0);
    // precompute
    for (int i1 = 0; i1 < 10; ++i1) {
        for (int i2 = 0; i2 < 10; ++i2)
            ++ways[2][i1+i2];
        ++ways[1][i1];
    }
    memset(filledin, -1, sizeof(filledin));
    int n, k, m, r, c, val;
    assert(cin >> n >> k >> m);
    assert(3 <= n && n <= N);
    assert(0 <= k && k <= K);
    assert(0 <= m && m <= 2 * n);
    for (int i = 0; i < m; ++i) {
        assert(cin >> c >> r >> val);
        assert(0 <= c && c < n);
        assert(0 <= r && r < 2);
        assert(0 <= val && val < 10);
        assert(filledin[c][r] == UNKNOWN);
        filledin[c][r] = val;
    }
    int res = 0;
    for (int i1 = 0; i1 <= min(k, 2 * 9); ++i1) {
        for (int i2 = 0; i2 <= min(k - i1, 2 * 9); ++i2) {
            if (int i3 = k - i1 - i2; i3 >= 0 && i3 <= 2 * 9) {
                res = (res + solve(n, k, { i1, i2, i3 })) % MOD;
            }
        }
    }
    cout << res << endl;
    return 0;
}
